/*void printBin(unsigned char val){
	unsigned char shift = 0x80;
	for(int i =0; i < 8; i++){
		if( i == 4){ printf(" "); }
		printf("%c",val&shift?'1':'0');
		shift = shift>>1;
	}
}*/
#include <stdio.h>
#include "ComPort.h"


void ComPort::showErr(char * caption){
LPVOID lpMsgBuf;
	FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER | 
		FORMAT_MESSAGE_FROM_SYSTEM | 
		FORMAT_MESSAGE_IGNORE_INSERTS,
		NULL,
		GetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
		(LPTSTR) &lpMsgBuf,
		0,
		NULL 
	);
	MessageBox( NULL, (LPCTSTR)lpMsgBuf, caption, MB_OK | MB_ICONINFORMATION );
	LocalFree( lpMsgBuf );
}



int ComPort::Read( char * buffer, int size){
unsigned long read; // how much did we read?
	ReadFile(comHand,buffer,size,&read,NULL);
	if(!read){showErr("Error reading from com port");}
	return read;
}


int ComPort::Write(char * buffer, int size){
unsigned long read;
	WriteFile(comHand,buffer,size,&read,NULL);
	if(!read){showErr("Error writing to com port");}
	return read;
}


bool ComPort::Open(int portNum){
	number = portNum;
	sprintf(name,"COM%d",portNum);
	comHand= CreateFile(name,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_FLAG_NO_BUFFERING,NULL);
	if(!comHand || comHand == INVALID_HANDLE_VALUE){
		showErr("Cannot open com port");
		return false;
	}
	if( !GetCommState(comHand,&oldDCB) ){
		showErr("ERROR getting com port configuration");
		return false;
	}
	if( !GetCommState(comHand,&cfg.dcb) ){
		showErr("ERROR getting com port configuration");
		return false;
	}
	if( !CommConfigDialog(name,NULL,&cfg) ){
		showErr("Cannot get com port configuration");
		return false;
	}
	if( !SetCommState(comHand,&cfg.dcb) ){
		showErr("ERROR while setting up com port");
		return false;
	}
	return true;
}


bool ComPort::Close(){
	if( !SetCommState(comHand,&oldDCB) ){
		showErr("ERROR while resetting com port to previous values");
	}
	return (bool) CloseHandle(comHand); // Close com port
}


ComPort::~ComPort(){
	Close();
}
