#include "FT639.h"

int FT639::init(int comPort,unsigned char pulse, unsigned char header){
	if ( ! port.Open(comPort) ){ return 1; }
	sendb(CMD_SETUP_MODE);	// make sure we're in setup mode
	sendb(pulse);			// set pulse width
	sendb(MASK_HEADER_LEN | (header &0x0F) );// set header len
	sendb(CMD_ACTIVE_MODE);
	return 0;
}

int FT639::set(unsigned char servo, unsigned char position){
	servo = (servo<<5)>>1; // get servo # in bits 4,5,6
	unsigned char hi = (position & 0xF0)>>4;
	unsigned char lo = position & 0x0F;
	sendb(servo | lo);		// lo nibble has to be sent first
	sendb(MASK_HI_BYTE | servo | hi); // then hi nibble
	return 0;
}

int FT639::sendb(char byte){
	return port.Write(&byte,1);
}


void FT639::turnoff(){
	sendb(CMD_SETUP_MODE); // turn servo off
}

void FT639::turnon(){
	sendb(CMD_ACTIVE_MODE); // turn servo off
}

FT639::~FT639(){
	turnoff();
}
