#include "ComPort.h"

#define CMD_ACTIVE_MODE		117	// active mode allows us to send servo position
#define CMD_SETUP_MODE		122	// put FT639 into setup mode where commands can be sent
#define CMD_SHORT_PULSE		85	// servo will make 90 degree turns
#define CMD_LONG_PULSE		90	// 180 degree turns
#define DEFAULT_HEADER		6	// .363ms for short and .597ms for long pulse
#define MASK_HEADER_LEN		96	// 0110 0000  - see FT639 documentation for this one
#define MASK_LO_BYTE		0	// 0000 0000
#define MASK_HI_BYTE		128	// 1000 0000

class FT639{ // FT639 is the name of the chip
	ComPort port;
	int sendb(char byte); // send byte to com port
public:
	void turnoff();
	void turnon();
	~FT639();
	int init(int comPort, unsigned char pulse, unsigned char header); // CMD_XXX_PULSE, 0-15
	int set(unsigned char servo, unsigned char position); // set servo position 
};